using System;
using System.IO;
using NUnit.Framework;

namespace Smdn.Formats.Thbgm {
  [TestFixture]
  public class ProductInfoTests {
    [Test]
    public void TestEmbeddedProductInfo()
    {
      Assert.IsNotNull(ProductInfo.Th06);
      Assert.IsNotNull(ProductInfo.Th07);
      Assert.IsNotNull(ProductInfo.Th08tr);
      Assert.IsNotNull(ProductInfo.Th08);
      Assert.IsNotNull(ProductInfo.Th09tr);
      Assert.IsNotNull(ProductInfo.Th09);
      Assert.IsNotNull(ProductInfo.Th10tr);
      Assert.IsNotNull(ProductInfo.Th10);

      Assert.AreEqual(17, ProductInfo.Th06.Tracks.Count,   "track count of Th06");
      Assert.AreEqual(20, ProductInfo.Th07.Tracks.Count,   "track count of Th07");
      Assert.AreEqual(7,  ProductInfo.Th08tr.Tracks.Count, "track count of Th08tr");
      Assert.AreEqual(21, ProductInfo.Th08.Tracks.Count,   "track count of Th08");
      Assert.AreEqual(7,  ProductInfo.Th09tr.Tracks.Count, "track count of Th09tr");
      Assert.AreEqual(19, ProductInfo.Th09.Tracks.Count,   "track count of Th09");
      Assert.AreEqual(7,  ProductInfo.Th10tr.Tracks.Count, "track count of Th10tr");
      Assert.AreEqual(18, ProductInfo.Th10.Tracks.Count,   "track count of Th10");

      foreach (var expected in new[] {
        new {Creator = ProductInfo.Th06.Creator, Message = "creator of Th06"},
        new {Creator = ProductInfo.Th07.Creator, Message = "creator of Th07"},
        new {Creator = ProductInfo.Th08.Creator, Message = "creator of Th08"},
        new {Creator = ProductInfo.Th09.Creator, Message = "creator of Th09"},
        new {Creator = ProductInfo.Th10.Creator, Message = "creator of Th10"},
      }) {
        Assert.AreEqual("上海アリス幻樂団", expected.Creator, expected.Message);
      }
    }
  }
}